import java.net.*;
import java.io.*;
import java.util.*;
import java.sql.*;

public class Server {

 public Server (int port) throws IOException {

  ServerSocket server = new ServerSocket (port);

  while (true) {

   Socket client = server.accept();
   Channel c = new Channel (client);
   c.start();

  }

 }

 public static void main (String args[]) throws IOException {

  new Server (9000);

 }

}

class Channel extends Thread {

 Socket s;
 DataInputStream dis;
 DataOutputStream dos;
 String msg1;
 protected static Vector vektor = new Vector();
 boolean pass = false;

 public Channel (Socket s) throws IOException {

  this.s = s;
  dis = new DataInputStream (new BufferedInputStream (s.getInputStream()));
  dos = new DataOutputStream (new BufferedOutputStream (s.getOutputStream()));

 }

 public void run () {

  try {

   vektor.addElement (this);

   while (true) {

    String msg = dis.readUTF ();
    sendSQL (msg);

   }

  }

  catch (IOException ex) {
   ex.printStackTrace ();
  }

  finally {

   vektor.removeElement (this);

   try {
    dis.close ();
    dos.close ();
    s.close();
   }

   catch (IOException ex) {
    ex.printStackTrace ();
   }

  }

 }

 public synchronized void sendSQL (String msg) {

  String URL = "jdbc:odbc:sample";
  String user = "";
  String password = "";
  Statement stmt = null;
  Connection con = null;

  try {
   Class.forName ("sun.jdbc.odbc.JdbcOdbcDriver");
  }

  catch (Exception e) {
   e.printStackTrace ();
   msg1 = "Can't connect to a database!" + "\n" + e.toString() +
   "\nServer message: end";
   send ();
   return;
  }

  try {
   con = DriverManager.getConnection (URL, user, password);
   stmt = con.createStatement ();
  }

  catch (Exception e) {
   e.printStackTrace ();
   msg1 = "Can't connect to a database!" + "\n" + e.toString() +
   "\nServer message: end";
   send ();
   return;
  }

  String ctrl = " ";
  ctrl = msg.substring (0, 4);

  if (ctrl.equalsIgnoreCase ("drop")) {
   msg1 = "You are restricted to drop existing tables.\nServer message: end";
   System.out.println ("Prosao");
   send ();
   return;
  }

  ctrl = " ";
  ctrl = msg.substring (0, 6);

  if (ctrl.equalsIgnoreCase ("create")) {
   msg1 = "You are restricted to create new tables.\nServer message: end";
   System.out.println ("Prosao");
   send ();
   return;
  }
 
  try {
   stmt.execute (msg);
  }

  catch (Exception e) {
   e.printStackTrace ();
   msg1 = "Error! Check the SQL Sentence!" + "\n" + e.toString() +
   "\nServer message: end";  
   send ();
   return;
  }

  try {

   int rows = stmt.getUpdateCount ();

   msg1 = "";

   if (rows >= 0) {
    msg1 = "The sentence was succesfully executed. Rows affected: " + rows +
    "\nServer message: end";
   }

   ResultSet result = stmt.getResultSet ();

   if (result != null) {
    try {
     ResultSetMetaData rsmd = result.getMetaData ();
     int cols = rsmd.getColumnCount ();

     while (result.next ()) {

      for (int i = 1; i <= cols; i ++) {
       if (i > 1) msg1 = msg1 + "   ,   ";
       msg1 = msg1 + result.getString (i);
      }

      send ();
      pass = true;

     }

     msg1 = "Server message: end";

     if (!pass)
      msg1 = "Data not found.\nServer message: end";

     pass = false;

    }
      
    catch (Exception e) {
     e.printStackTrace ();
     msg1 = "Error! Check the SQL Sentence!" + "\n" + e.toString() +
     "\nServer message: end";  
    }

   }

  send ();

  con.close ();

  }

  catch (SQLException e) {
   e.printStackTrace ();
   msg1 = "Error! Check the SQL Sentence!" + "\n" + e.toString() +
   "\nServer message: end";
   send ();
  }
  
 }

 public void send () {

  synchronized (vektor) {

   int position = vektor.indexOf (this);
   Channel c = (Channel) vektor.elementAt (position);

   try {

    synchronized (c.dos) {
     c.dos.writeUTF (msg1);
    }

   c.dos.flush ();

   }

   catch (Exception e) {
    c.stop ();
   }

   msg1 = "";

  } 

 }
 
}

